"""
    FactSet Estimates

    Gain access to 20+ years of comprehensive estimates and statistics of over 250+ estimated metrics, including financial statement items, product segments, geosegments, and industry metrics. FactSet's consensus estimates are aggregated from a wide base of over 800+ contributors and cover over 19,000 active companies across 90+ countries. Data returned can be accessed on the data frequencies based on quarterly, fiscal years, and calendar years. FactSet Estimates updates on a real time basis intraday (every 5 minutes). Updating times vary based on earning season vs. non-earning season but the goal is to have the data available to the client within a few hours that FactSet receives updated information. Often times updates times can be much faster as FactSet has always been known as one of the fastest estimate providers in the market.   # noqa: E501

    The version of the OpenAPI document: 2.3.1
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.FactSetEstimates.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.FactSetEstimates.exceptions import ApiAttributeError



class DetailEstimate(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'fsym_id': (str,),  # noqa: E501
            'metric': (str,),  # noqa: E501
            'periodicity': (str,),  # noqa: E501
            'fiscal_year': (int,),  # noqa: E501
            'fiscal_period': (int,),  # noqa: E501
            'fiscal_end_date': (date,),  # noqa: E501
            'relative_period': (int,),  # noqa: E501
            'currency': (str,),  # noqa: E501
            'estimate_date': (date,),  # noqa: E501
            'estimate_value': (float,),  # noqa: E501
            'analyst_id': (str,),  # noqa: E501
            'analyst_name': (str,),  # noqa: E501
            'broker_id': (str,),  # noqa: E501
            'broker_name': (str,),  # noqa: E501
            'prev_estimate_date': (date,),  # noqa: E501
            'prev_estimate_value': (float,),  # noqa: E501
            'section': (str,),  # noqa: E501
            'status_code': (int,),  # noqa: E501
            'status_text': (str,),  # noqa: E501
            'request_id': (str,),  # noqa: E501
            'input_date_time': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'fsym_id': 'fsymId',  # noqa: E501
        'metric': 'metric',  # noqa: E501
        'periodicity': 'periodicity',  # noqa: E501
        'fiscal_year': 'fiscalYear',  # noqa: E501
        'fiscal_period': 'fiscalPeriod',  # noqa: E501
        'fiscal_end_date': 'fiscalEndDate',  # noqa: E501
        'relative_period': 'relativePeriod',  # noqa: E501
        'currency': 'currency',  # noqa: E501
        'estimate_date': 'estimateDate',  # noqa: E501
        'estimate_value': 'estimateValue',  # noqa: E501
        'analyst_id': 'analystId',  # noqa: E501
        'analyst_name': 'analystName',  # noqa: E501
        'broker_id': 'brokerId',  # noqa: E501
        'broker_name': 'brokerName',  # noqa: E501
        'prev_estimate_date': 'prevEstimateDate',  # noqa: E501
        'prev_estimate_value': 'prevEstimateValue',  # noqa: E501
        'section': 'section',  # noqa: E501
        'status_code': 'statusCode',  # noqa: E501
        'status_text': 'statusText',  # noqa: E501
        'request_id': 'requestId',  # noqa: E501
        'input_date_time': 'inputDateTime',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """DetailEstimate - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            fsym_id (str): [optional]  # noqa: E501
            metric (str): Company's Financial statement 'metric' that is estimated. Use the factset-estimates/v#/metrics endpoint for a complete list. For more details, visit [Online Assistant Page #15034](https://oa.apps.factset.com/pages/15034).. [optional]  # noqa: E501
            periodicity (str): Company's 'periodicity' for the estimate record, reflecting Annual, Quarterly, or Semi-Annual report periods.. [optional]  # noqa: E501
            fiscal_year (int): Company's 'fiscal year' for the estimate record. [optional]  # noqa: E501
            fiscal_period (int): Company's 'fiscal period' for the estimate record.  'Periodicity' defines context for period.. [optional]  # noqa: E501
            fiscal_end_date (date): Company's 'fiscal end date' for the estimate record expressed in YYYY-MM-DD format. [optional]  # noqa: E501
            relative_period (int): 'Fiscal period' based on relationship to 'estimate date'. This is not applicable for fixed-consensus endpoint. For more details, visit [Online Assistant Page #16598](https://oa.apps.factset.com/pages/16598). [optional]  # noqa: E501
            currency (str): Currency used estimates in consensus calculations. Currency used estimates in consensus calculations. For a list of currency ISO codes, visit [Online Assistant Page #1470](https://oa.apps.factset.com/pages/1470).. [optional]  # noqa: E501
            estimate_date (date): Date of estimate expressed in YYYY-MM-DD format. For more details, visit [Online Assistant Page #16598](https://oa.apps.factset.com/pages/16598). [optional]  # noqa: E501
            estimate_value (float): The value of the estimate.. [optional]  # noqa: E501
            analyst_id (str): The FactSet Entity Identifier for the analyst making the estimate.. [optional]  # noqa: E501
            analyst_name (str): The name of the analyst making the estimate.. [optional]  # noqa: E501
            broker_id (str): The FactSet Entity Identifier for the broker making the estimate.. [optional]  # noqa: E501
            broker_name (str): The name of the broker making the estimate.. [optional]  # noqa: E501
            prev_estimate_date (date): Date the previous estimate was made expressed in YYYY-MM-DD format. For more details, visit [Online Assistant Page #16598](https://oa.apps.factset.com/pages/16598). [optional]  # noqa: E501
            prev_estimate_value (float): The value of the previous estimate.. [optional]  # noqa: E501
            section (str): Section of the estimate.Returns the details of brokers inlcuded and excluded in the consensus. [optional]  # noqa: E501
            status_code (int): Status code of the estimate.. [optional]  # noqa: E501
            status_text (str): Status description of the estimate.. [optional]  # noqa: E501
            request_id (str): Identifier that was used for the request.. [optional]  # noqa: E501
            input_date_time (str): Date and time when the data is available at the source.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """DetailEstimate - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            fsym_id (str): [optional]  # noqa: E501
            metric (str): Company's Financial statement 'metric' that is estimated. Use the factset-estimates/v#/metrics endpoint for a complete list. For more details, visit [Online Assistant Page #15034](https://oa.apps.factset.com/pages/15034).. [optional]  # noqa: E501
            periodicity (str): Company's 'periodicity' for the estimate record, reflecting Annual, Quarterly, or Semi-Annual report periods.. [optional]  # noqa: E501
            fiscal_year (int): Company's 'fiscal year' for the estimate record. [optional]  # noqa: E501
            fiscal_period (int): Company's 'fiscal period' for the estimate record.  'Periodicity' defines context for period.. [optional]  # noqa: E501
            fiscal_end_date (date): Company's 'fiscal end date' for the estimate record expressed in YYYY-MM-DD format. [optional]  # noqa: E501
            relative_period (int): 'Fiscal period' based on relationship to 'estimate date'. This is not applicable for fixed-consensus endpoint. For more details, visit [Online Assistant Page #16598](https://oa.apps.factset.com/pages/16598). [optional]  # noqa: E501
            currency (str): Currency used estimates in consensus calculations. Currency used estimates in consensus calculations. For a list of currency ISO codes, visit [Online Assistant Page #1470](https://oa.apps.factset.com/pages/1470).. [optional]  # noqa: E501
            estimate_date (date): Date of estimate expressed in YYYY-MM-DD format. For more details, visit [Online Assistant Page #16598](https://oa.apps.factset.com/pages/16598). [optional]  # noqa: E501
            estimate_value (float): The value of the estimate.. [optional]  # noqa: E501
            analyst_id (str): The FactSet Entity Identifier for the analyst making the estimate.. [optional]  # noqa: E501
            analyst_name (str): The name of the analyst making the estimate.. [optional]  # noqa: E501
            broker_id (str): The FactSet Entity Identifier for the broker making the estimate.. [optional]  # noqa: E501
            broker_name (str): The name of the broker making the estimate.. [optional]  # noqa: E501
            prev_estimate_date (date): Date the previous estimate was made expressed in YYYY-MM-DD format. For more details, visit [Online Assistant Page #16598](https://oa.apps.factset.com/pages/16598). [optional]  # noqa: E501
            prev_estimate_value (float): The value of the previous estimate.. [optional]  # noqa: E501
            section (str): Section of the estimate.Returns the details of brokers inlcuded and excluded in the consensus. [optional]  # noqa: E501
            status_code (int): Status code of the estimate.. [optional]  # noqa: E501
            status_text (str): Status description of the estimate.. [optional]  # noqa: E501
            request_id (str): Identifier that was used for the request.. [optional]  # noqa: E501
            input_date_time (str): Date and time when the data is available at the source.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
